#!c:/perl/bin/perl.exe
use warnings;
use strict;
use diagnostics;

open (my $in,"Resources/single_fasta.txt") or die "Can't read Fasta file: $!";

my $name;
my $sequence;

while (<$in>) {
	chomp;
	if (/^>(\S+)/) {
		$name = $1;
	}
	else {
		s/\s+//g;
		$sequence .= $_;	
	}
}

unless ($name) {
	die "Didn't parse a sequence name - can't open output file";	
}

open (my $out,'>',"Resources/${name}_map.txt") or die "Can't write output file for $name: $!";

# Print out report header
print $out "Restriction Report for $name\n";

# Now find the restriction sites.

# EcoR1
while ($sequence =~ /gaattc/ig) {
	# Pos returns the position of the end of the match (starting from 0)
	# we therefore need to subtract 4 to get the position of the first a
	print $out "EcoR1\t",pos($sequence)-4,"\n";	
}

# Btg1
while ($sequence =~ /cc[ag][ct]gg/ig) {
	print $out "Btg1\t",pos($sequence)-4,"\n";
}

# Msl1
while ($sequence =~ /ca[ct][gatc]{4}[ag]tg/ig) {
	print $out "Msl1\t",pos($sequence)-4,"\n";	
}
